package vc.thinker.thirdpartyproxy.protocolimpls.centralAir;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import vc.thinker.absctacts.protocolproxy.enums.IProtocolType;
import vc.thinker.absctacts.protocolproxy.protocol.AbstractThirdPartyProtocol;
import vc.thinker.config.device.DeviceInfoConfig;
import vc.thinker.mqtt.forwardthinker.ThinkerProdProtocolClient;
import vc.thinker.mqtt.forwardthinker.dto.ThinkerReportDTO;
import vc.thinker.thirdpartyproxy.ProtocolType;
import vc.thinker.thirdpartyproxy.protocolimpls.centralAir.dto.DataReportInfoDTO;

/**
 * 中央空调代理上报网关协议
 *
 * @author HeTongHao
 * @since 2021/7/9 17:13
 */
@Slf4j
@Component
@RequiredArgsConstructor
public class CentralAirProtocol extends AbstractThirdPartyProtocol implements TerminalReportData {

    @Autowired
    private DeviceInfoConfig deviceInfoConfig;

    @Autowired
    protected ThinkerProdProtocolClient thinkerProdProtocolClient;

    @Override
    public IProtocolType protocolType() {
        return ProtocolType.central_air_conditioning;
    }

    @Override
    public String lastDeviceId(DataReportInfoDTO dataReportInfoDTO) {
        return deviceInfoConfig.getCode();
    }

    @Override
    public void dataReport(DataReportInfoDTO dataReportInfoDTO) {
        ThinkerReportDTO dto = new ThinkerReportDTO();
        dto.setDeviceCode(deviceInfoConfig.getCode());
        dto.setTimestamp(dataReportInfoDTO.getTimestamp());
//        JSONObject dataMap = new JSONObject();
//        DataReportParamDTO paramDTO = dataReportInfoDTO.getData();
//        if (!ObjectUtils.isEmpty(paramDTO.getElectricity())){
//            dataMap.put(CentralAirMeterAttrDefine.electricity.getCode(), dataReportInfoDTO.getData().getElectricity());
//        }
//        if (!ObjectUtils.isEmpty(paramDTO.getColdCapacity())) {
//            dataMap.put(CentralAirMeterAttrDefine.coldCapacity.getCode(), dataReportInfoDTO.getData().getColdCapacity());
//        }
//        if (!ObjectUtils.isEmpty(paramDTO.getSystemCop())) {
//            dataMap.put(CentralAirMeterAttrDefine.systemCop.getCode(), dataReportInfoDTO.getData().getSystemCop());
//        }
//        if (!ObjectUtils.isEmpty(paramDTO.getSupplyWaterTemp())) {
//            dataMap.put(CentralAirMeterAttrDefine.supplyWaterTemp.getCode(), dataReportInfoDTO.getData().getSupplyWaterTemp());
//        }
//        if (!ObjectUtils.isEmpty(paramDTO.getReturnWaterTemp())) {
//            dataMap.put(CentralAirMeterAttrDefine.returnWaterTemp.getCode(), dataReportInfoDTO.getData().getReturnWaterTemp());
//        }
        dto.setDatas(dataReportInfoDTO.getData());
        thinkerProdProtocolClient.report(protocolType().getCode(),dto);
    }
}
